#!/bin/bash

# GenInfoString - used by other scripts

# $Id: GenInfo.sh,v 1.2 2018/11/22 18:06:21 pkabal Exp $

RecCond="Anechoic room, Sony ECM-909A microphone,
Sony TCD-D2 DAT recorder"

#==========
function GenInfoString ()
# Input FileI
#       TextFile
#       DBID
# Output $InfoDate
#        $InfoTitle
#        $InfoDB
#        $InfoID
#        $InfoRecCond
#        $InfoSpkr
#        $InfoText
{
  local File
  local FileI
  local TextFile
  local DBID
  local Speaker
  local bname
  local SID
  local Text
  local GL
  
  FileI="$1"
  TextFile="$2"
  DBID="$3"

# Pick apart the file name
# See linuxgazette.net/18/bash.html
  fname=${FileI##*/}    # Trim longest match to */ from the beginning
  # example: fname="FA01_01.wav"
  Speaker=${fname:0:2}  # Speaker ID ("FA"), offset 0, 2 characters
  SID=${fname:2:5}      # Sentence ID ("01_01"), offset 2, 5 characters
  GL=${fname:0:1}       # Gender ("F"), offset 0, 1 character

  if [ $GL = "F" ]; then
    SInfo="Female"
  elif [ $GL = "M" ]; then
    SInfo="Male"
  elif [ $Speaker = "CA" ]; then
    SInfo="Female (age 12)"
  elif [ $Speaker = "CB" ]; then
    SInfo="Female (age 10)"
  else
    echo "Error: Invalid speaker code" 1>&2
  fi

# Pick up the text from $TextFile
  Text=`sed -n -e "/^$SID:/ {s/.*://p;q}" $TextFile`
  
#------
  InfoTitle="title: $SInfo speaker, $Speaker$SID $DBID"
  InfoDB="database: TSP Speech Files v2"
  InfoID="ID: TSP $Speaker$SID $DBID"
  InfoRecCond="recording_conditions: $RecCond"
  InfoSpkr="speaker: $Speaker $SInfo"
  InfoText="text: \"$Text\""
}
